import React from 'react'
import ReactDOMServer from 'react-dom/server'
import Downshift from '../../../src'

test('does not throw an error when server rendering', () => {
  expect(() => {
    ReactDOMServer.renderToString(
      <Downshift id="my-autocomplete-component">
        {({getInputProps, getLabelProps}) => (
          <div>
            <label {...getLabelProps({htmlFor: 'my-autocomplete-input'})} />
            <input {...getInputProps({id: 'my-autocomplete-input'})} />
          </div>
        )}
      </Downshift>,
    )
  }).not.toThrow()
})

test('resets idCounter', () => {
  const getRenderedString = () => {
    Downshift.resetIdCounter()
    return ReactDOMServer.renderToString(
      <Downshift id="my-autocomplete-component">
        {({getInputProps, getLabelProps}) => (
          <div>
            <label {...getLabelProps()} />
            <input {...getInputProps()} />
          </div>
        )}
      </Downshift>,
    )
  }

  const firstRun = getRenderedString()
  const secondRun = getRenderedString()

  expect(firstRun).toBe(secondRun)
})

/* eslint jsx-a11y/label-has-for:0 */
